SystemOrganization addCategory: #'SqSquare-Client'!
SystemOrganization addCategory: #'SqSquare-Client-UI'!
SystemOrganization addCategory: #'SqSquare-Client-AudioChat'!
SystemOrganization addCategory: #'SqSquare-Client-Discovery'!

CScrollPaneCostume subclass: #SqScrollPaneCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqScrollPaneCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="commandRegion" toSet="commandRegion:" changeEvent="commandRegionChanged">commandRegion</field>
	<field toGet="map" toSet="map:" changeEvent="mapChanged">map</field>
</fields>'!

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:30'!
commandRegion
	"Answer the commandRegion of the receiver"
	<bewareOf: #commandRegionChanged>
	^self propertyValueAt: #commandRegion! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:30'!
commandRegion: aValue
	"Modify the receiver's commandRegion"
	^self propertyValueAt: #commandRegion put: aValue with: #commandRegionChanged! !

!SqScrollPaneCostume methodsFor: 'initialize' stamp: 'minami 3/9/2006 16:43'!
initialize
	super initialize.
	self define: #commandRegion as: CPlayer new.

	self startScript: #onMouseEnterCommandRegion when: {commandRegion. #mouseEnter}! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:54'!
map
	"Answer the map of the receiver"
	<bewareOf: #mapChanged>
	^self propertyValueAt: #map! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:54'!
map: aValue
	"Modify the receiver's map"
	^self propertyValueAt: #map put: aValue with: #mapChanged! !

!SqScrollPaneCostume methodsFor: 'events' stamp: 'minami 3/9/2006 17:10'!
onMouseEnterCommandRegion
	| board |
	board := self container board.
	self container board ifNil: [^ self].

	map ifNil: [
		map := SqBoardMap for: board.
		map startScript: #hide when: {map. #mouseLeave}.
	].
	map openAt: (self hand position - map extent).
	map show.

! !

!SqScrollPaneCostume methodsFor: 'layout' stamp: 'minami 3/9/2006 16:33'!
onUpdateLayout
	"update the position of all the elements"
	| inset box |
	<on: layoutChanged>
	box := self costume innerBounds.
	inset := 0@0.
	hScrollBar visible ifTrue:[inset := inset x @ hScrollBar height].
	vScrollBar visible ifTrue:[inset := vScrollBar width @ inset y].
	self positionTarget: inset in: box.
	hScrollBar visible ifTrue:[self positionHScrollBar: inset in: box].
	vScrollBar visible ifTrue:[self positionVScrollBar: inset in: box].
	
	self positionCommandRegion: inset in: box! !

!SqScrollPaneCostume methodsFor: 'layout' stamp: 'minami 3/9/2006 16:35'!
positionCommandRegion: inset in: box
	commandRegion left: box right - inset x.
	commandRegion top: box bottom - inset y.
	commandRegion width: inset x.
	commandRegion height: inset y.! !

!SqScrollPaneCostume methodsFor: 'initialize' stamp: 'minami 3/10/2006 12:24'!
setupCostume
	super setupCostume.
	
	self commandRegion 
			extent: 18@18; 
			color: Color red;
			text: 'v';
			textFont: (TextStyle named: 'HaloFont') defaultFont.
	self add: self commandRegion.! !

CCostume subclass: #SqAudioChatCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatCostume class
	instanceVariableNames: 'images'!

SqAudioChatCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="startButton" toSet="startButton:" changeEvent="startButtonChanged">startButton</field>
	<field toGet="talkButton" toSet="talkButton:" changeEvent="talkButtonChanged">talkButton</field>
	<field toGet="levelIndicator" toSet="levelIndicator:" changeEvent="levelIndicatorChanged">levelIndicator</field>
	<field toGet="listenToMyselfButton" toSet="listenToMyselfButton:" changeEvent="listenToMyselfButtonChanged">listenToMyselfButton</field>
	<field toGet="userList" toSet="userList:" changeEvent="userListChanged">userList</field>
</fields>'!

!SqAudioChatCostume class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 06:36'!
initialize
	images := Dictionary new! !

!SqAudioChatCostume class methodsFor: 'private' stamp: 'minami 3/27/2006 06:43'!
talkButtonImage
	^ images
		at: #talkButtonImage
		ifAbsentPut: [Form fromCompactBytes: self talkButtonImageArray]! !

!SqAudioChatCostume class methodsFor: 'private' stamp: 'minami 3/27/2006 06:44'!
talkButtonImageArray
	^ #(2 8 0 11 0 13 0 0 0 0 1 0 0 255 0 0 128 255 0 128 0 255 0 128 128 255 128 0 0 255 128 0 128 255 128 128 0 255 192 192 192 255 192 220 192 255 240 202 166 255 0 32 64 255 0 32 96 255 0 32 128 255 0 32 160 255 0 32 192 255 0 32 224 255 0 64 0 255 0 64 32 255 0 64 64 255 0 64 96 255 0 64 128 255 0 64 160 255 0 64 192 255 0 64 224 255 0 96 0 255 0 96 32 255 0 96 64 255 0 96 96 255 0 96 128 255 0 96 160 255 0 96 192 255 0 96 224 255 0 128 0 255 0 128 32 255 0 128 64 255 0 128 96 255 0 128 128 255 0 128 160 255 0 128 192 255 0 128 224 255 0 160 0 255 0 160 32 255 0 160 64 255 0 160 96 255 0 160 128 255 0 160 160 255 0 160 192 255 0 160 224 255 0 192 0 255 0 192 32 255 0 192 64 255 0 192 96 255 0 192 128 255 0 192 160 255 0 192 192 255 0 192 224 255 0 224 0 255 0 224 32 255 0 224 64 255 0 224 96 255 0 224 128 255 0 224 160 255 0 224 192 255 0 224 224 255 64 0 0 255 64 0 32 255 64 0 64 255 64 0 96 255 64 0 128 255 64 0 160 255 64 0 192 255 64 0 224 255 64 32 0 255 64 32 32 255 64 32 64 255 64 32 96 255 64 32 128 255 64 32 160 255 64 32 192 255 64 32 224 255 64 64 0 255 64 64 32 255 64 64 64 255 64 64 96 255 64 64 128 255 64 64 160 255 64 64 192 255 64 64 224 255 64 96 0 255 64 96 32 255 64 96 64 255 64 96 96 255 64 96 128 255 64 96 160 255 64 96 192 255 64 96 224 255 64 128 0 255 64 128 32 255 64 128 64 255 64 128 96 255 64 128 128 255 64 128 160 255 64 128 192 255 64 128 224 255 64 160 0 255 64 160 32 255 64 160 64 255 64 160 96 255 64 160 128 255 64 160 160 255 64 160 192 255 64 160 224 255 64 192 0 255 64 192 32 255 64 192 64 255 64 192 96 255 64 192 128 255 64 192 160 255 64 192 192 255 64 192 224 255 64 224 0 255 64 224 32 255 64 224 64 255 64 224 96 255 64 224 128 255 64 224 160 255 64 224 192 255 64 224 224 255 128 0 0 255 128 0 32 255 128 0 64 255 128 0 96 255 128 0 128 255 128 0 160 255 128 0 192 255 128 0 224 255 128 32 0 255 128 32 32 255 128 32 64 255 128 32 96 255 128 32 128 255 128 32 160 255 128 32 192 255 128 32 224 255 128 64 0 255 128 64 32 255 128 64 64 255 128 64 96 255 128 64 128 255 128 64 160 255 128 64 192 255 128 64 224 255 128 96 0 255 128 96 32 255 128 96 64 255 128 96 96 255 128 96 128 255 128 96 160 255 128 96 192 255 128 96 224 255 128 128 0 255 128 128 32 255 128 128 64 255 128 128 96 255 128 128 128 255 128 128 160 255 128 128 192 255 128 128 224 255 128 160 0 255 128 160 32 255 128 160 64 255 128 160 96 255 128 160 128 255 128 160 160 255 128 160 192 255 128 160 224 255 128 192 0 255 128 192 32 255 128 192 64 255 128 192 96 255 128 192 128 255 128 192 160 255 128 192 192 255 128 192 224 255 128 224 0 255 128 224 32 255 128 224 64 255 128 224 96 255 128 224 128 255 128 224 160 255 128 224 192 255 128 224 224 255 192 0 0 255 192 0 32 255 192 0 64 255 192 0 96 255 192 0 128 255 192 0 160 255 192 0 192 255 192 0 224 255 192 32 0 255 192 32 32 255 192 32 64 255 192 32 96 255 192 32 128 255 192 32 160 255 192 32 192 255 192 32 224 255 192 64 0 255 192 64 32 255 192 64 64 255 192 64 96 255 192 64 128 255 192 64 160 255 192 64 192 255 192 64 224 255 192 96 0 255 192 96 32 255 192 96 64 255 192 96 96 255 192 96 128 255 192 96 160 255 192 96 192 255 192 96 224 255 192 128 0 255 192 128 32 255 192 128 64 255 192 128 96 255 192 128 128 255 192 128 160 255 192 128 192 255 192 128 224 255 192 160 0 255 192 160 32 255 192 160 64 255 192 160 96 255 192 160 128 255 192 160 160 255 192 160 192 255 192 160 224 255 192 192 0 255 192 192 32 255 192 192 64 255 192 192 96 255 192 192 128 255 192 192 160 255 240 251 255 255 164 160 160 255 128 128 128 255 0 0 0 0 0 255 0 255 0 255 255 255 255 0 0 255 255 0 255 255 255 255 0 255 255 255 255 255 128 156 39 5 249 155 249 249 249 73 82 82 249 0 249 249 249 249 249 249 82 8 91 8 82 0 249 249 249 249 249 247 73 91 246 82 82 0 249 249 249 249 247 82 82 8 155 7 82 0 249 249 249 155 82 155 82 73 82 73 249 0 249 249 155 82 82 82 82 247 249 249 249 0 249 91 82 82 82 82 247 249 249 249 249 0 249 73 73 82 82 249 249 249 249 249 249 0 249 73 73 91 249 249 249 249 249 249 249 0 164 91 247 247 249 249 249 249 249 249 249 0 82 164 249 249 249 91 164 249 249 249 249 0 249 73 155 155 82 155 249 249 249 249 249 0 249 247 164 164 247 249 249 249 249 249 249 0) asByteArray! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:44'!
buildChatUserList
	^ SqAudioChatUserList new.! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:43'!
buildLevelIndicator
	| indicator |
	indicator := SqLevelIndicator new.
	indicator extent: self levelIndicatorExtent.
	^ indicator! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
buildRowPlayer
	| aRow |
	aRow := CPlayer new.
	aRow layout: CTableLayout new.
	aRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aRow layout listDirection: #leftToRight.
	^ aRow! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/27/2006 06:45'!
buildTalkButton
	| button |
	button :=  CButton new.
	button extent: self talkButtonExtent.
	button color: Color veryLightGray.
	button image: self class talkButtonImage.
	^ button! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/9/2006 12:35'!
chatClient
	^ self player chatClient! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/7/2006 19:26'!
client
	^ self player client! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/9/2006 12:35'!
commandClient
	^ self player commandClient! !

!SqAudioChatCostume methodsFor: 'initialize' stamp: 'minami 3/7/2006 18:44'!
defaultPlayer
	^ SqAudioChatPlayer! !

!SqAudioChatCostume methodsFor: 'initialize' stamp: 'minami 3/7/2006 13:49'!
initialize
	super initialize! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator
	"Answer the levelIndicator of the receiver"
	<bewareOf: #levelIndicatorChanged>
	^self propertyValueAt: #levelIndicator! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
levelIndicatorExtent
	^ 64@20! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator: aValue
	"Modify the receiver's levelIndicator"
	^self propertyValueAt: #levelIndicator put: aValue with: #levelIndicatorChanged! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/8/2006 15:18'!
listenToMyselfButton
	"Answer the listenToMyselfButton of the receiver"
	<bewareOf: #listenToMyselfButtonChanged>
	^self propertyValueAt: #listenToMyselfButton! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/8/2006 15:18'!
listenToMyselfButton: aValue
	"Modify the receiver's listenToMyselfButton"
	^self propertyValueAt: #listenToMyselfButton put: aValue with: #listenToMyselfButtonChanged! !

!SqAudioChatCostume methodsFor: 'events' stamp: 'minami 3/8/2006 15:24'!
onListenToMySelfButtonFired
	| aBoolean |

	<on: fire in: listenToMyselfButton>

	aBoolean := PopUpMenu confirm: 'listen to yourself?'.
	self chatClient sendListenToMyselfCommand: aBoolean.
! !

!SqAudioChatCostume methodsFor: 'events' stamp: 'minami 3/23/2006 08:00'!
onStartButtonFired
	<on: fire in: startButton>

	^ self player isRunning
		ifTrue: [self privStop]
		ifFalse: [self privStart]! !

!SqAudioChatCostume methodsFor: 'events' stamp: 'minami 3/7/2006 18:56'!
onTalkButtonFired
	<on: fire in: talkButton>

	self player chatClient ifNotNilDo: [:cc |
		cc isSpeaking 
			ifTrue: [cc stopSpeaking.
					self levelIndicator reset] 
			ifFalse: [cc sendWantsToSpeakCommand].
	].
! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/23/2006 08:00'!
privStart
	self player start! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/23/2006 08:00'!
privStop
	self player stop.
	self userList removeAll! !

!SqAudioChatCostume methodsFor: 'initialize' stamp: 'minami 3/27/2006 06:48'!
setupCostume
	| controllerRow debugRow |

	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.


	SqSettings isDebugging ifTrue: [
		debugRow := self buildRowPlayer.
		self add: debugRow.

		self startButton: CButton new.
		self startButton extent: self levelIndicatorExtent.
		self startButton label: 'start/stop'.
		debugRow add: self startButton.

		self listenToMyselfButton: CButton new.
		self listenToMyselfButton extent: self talkButtonExtent.
		self listenToMyselfButton label: '@'.
		debugRow add: self listenToMyselfButton.
	].

	controllerRow := self buildRowPlayer.
	self add: controllerRow.

	self talkButton: self buildTalkButton.
	self chatClient ifNotNilDo: [:cc | cc talkButton: self talkButton].
	controllerRow add: self talkButton.

	self levelIndicator: self buildLevelIndicator.
	self chatClient ifNotNilDo: [:cc | cc levelIndicator: self levelIndicator].
	controllerRow add: self levelIndicator.

	self userList: self buildChatUserList.
	self client ifNotNilDo: [:c | c userList: self userList].
	self chatClient ifNotNilDo: [:c | c userList: self userList].
	self add: self userList.

! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
spacerExtent
	^ 3@20! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton
	"Answer the startButton of the receiver"
	<bewareOf: #startButtonChanged>
	^self propertyValueAt: #startButton! !

!SqAudioChatCostume methodsFor: 'private' stamp: 'minami 3/7/2006 19:03'!
startButtonLabel
	^ 'start/stop'! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton: aValue
	"Modify the receiver's startButton"
	^self propertyValueAt: #startButton put: aValue with: #startButtonChanged! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton
	"Answer the talkButton of the receiver"
	<bewareOf: #talkButtonChanged>
	^self propertyValueAt: #talkButton! !

!SqAudioChatCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
talkButtonExtent
	^ 32@20! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton: aValue
	"Modify the receiver's talkButton"
	^self propertyValueAt: #talkButton put: aValue with: #talkButtonChanged! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:15'!
userList
	"Answer the userList of the receiver"
	<bewareOf: #userListChanged>
	^self propertyValueAt: #userList! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:15'!
userList: aValue
	"Modify the receiver's userList"
	^self propertyValueAt: #userList put: aValue with: #userListChanged! !

CCostume subclass: #SqBoardHolderCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardHolderCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
	<field toGet="tabPane" toSet="tabPane:" changeEvent="tabPaneChanged">tabPane</field>
	<field toGet="contentHolder" toSet="contentHolder:" changeEvent="contentHolderChanged">contentHolder</field>
	<field toGet="menuPane" toSet="menuPane:" changeEvent="menuPaneChanged">menuPane</field>
	<field toGet="loginButton" toSet="loginButton:" changeEvent="loginButtonChanged">loginButton</field>
	<field toGet="boardButton" toSet="boardButton:" changeEvent="boardButtonChanged">boardButton</field>
	<field toGet="restartPlayerButton" toSet="restartPlayerButton:" changeEvent="restartPlayerButtonChanged">restartPlayerButton</field>
</fields>'!

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:20'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:20'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:09'!
boardButton
	"Answer the boardButton of the receiver"
	<bewareOf: #boardButtonChanged>
	^self propertyValueAt: #boardButton! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:09'!
boardButton: aValue
	"Modify the receiver's boardButton"
	^self propertyValueAt: #boardButton put: aValue with: #boardButtonChanged! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/27/2006 06:12'!
buildBoardButton
	^ CButton new label: 'select boards';
		 yourself! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 15:45'!
buildContentHolder
	| aHolder |
	aHolder := CPlayer new.

	aHolder hResizing: #spaceFill; vResizing: #shrinkWrap.
	aHolder color: self defaultContentHolderColor.


	^ aHolder
! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 15:33'!
buildLoginButton
	^ CButton new label: 'login';
		 yourself! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 14:58'!
buildMenuPane
	^ self buildRowPane! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/27/2006 11:44'!
buildRestartPlayerButton
	^ CButton new label: 'restart EventPlayer';
		 width: 125;
		 yourself! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 15:45'!
buildRowPane
	| aPane |
	aPane := CPlayer new.

	aPane hResizing: #spaceFill.
	aPane height: 20.
	aPane layout: CTableLayout new.
	aPane layout listDirection: #leftToRight.

	aPane color: self defaultRowColor.

	^ aPane
! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/29/2006 15:41'!
buildSpacer
	^ self buildSpacer: 2@1! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/29/2006 15:40'!
buildSpacer: specerExtent
	| aPlayer |
	aPlayer := CPlayer new.
	aPlayer extent: specerExtent.
	aPlayer color: Color transparent.
	^ aPlayer
! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 14:58'!
buildTabPane
	^ self buildRowPane! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/22/2006 20:30'!
contentExtent
	^ self extent x @ (self extent y - self tabPane extent y - self menuPane extent y).
! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
contentHolder
	"Answer the contentHolder of the receiver"
	<bewareOf: #contentHolderChanged>
	^self propertyValueAt: #contentHolder! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
contentHolder: aValue
	"Modify the receiver's contentHolder"
	^self propertyValueAt: #contentHolder put: aValue with: #contentHolderChanged! !

!SqBoardHolderCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 14:55'!
defaultContentHolderColor
	^ Color lightGray! !

!SqBoardHolderCostume methodsFor: 'initialize' stamp: 'minami 3/17/2006 15:31'!
defaultPlayer

	^ SqBoardHolder! !

!SqBoardHolderCostume methodsFor: 'defaults' stamp: 'minami 3/29/2006 15:43'!
defaultRowColor
	^ Color lightOrange lighter lighter! !

!SqBoardHolderCostume methodsFor: 'initialize' stamp: 'minami 3/27/2006 06:05'!
initialize
	super initialize.

	self define: #loginButton as: self buildLoginButton.
	self define: #boardButton as: self buildBoardButton.
	self define: #restartPlayerButton as: self buildRestartPlayerButton.
	self define: #menuPane as: self buildMenuPane.

	self define: #contentHolder as: self buildContentHolder.
	self define: #tabPane as: self buildTabPane.

! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:56'!
loginButton
	"Answer the loginButton of the receiver"
	<bewareOf: #loginButtonChanged>
	^self propertyValueAt: #loginButton! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:56'!
loginButton: aValue
	"Modify the receiver's loginButton"
	^self propertyValueAt: #loginButton put: aValue with: #loginButtonChanged! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:56'!
menuPane
	"Answer the menuPane of the receiver"
	<bewareOf: #menuPaneChanged>
	^self propertyValueAt: #menuPane! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:56'!
menuPane: aValue
	"Modify the receiver's menuPane"
	^self propertyValueAt: #menuPane put: aValue with: #menuPaneChanged! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/23/2006 08:04'!
onActiveContentChanged
	| activeButton |
	<on: activeContentChanged in: player>

	self activeContent == player activeContent ifTrue: [^ self].

	self activeContent ifNotNil: [
		self contentHolder remove: self activeContent.
	].
	self activeContent: player activeContent.
	self contentHolder addLast: self activeContent.

	self player contents do: [:each | each beBackground].
	self tabButtons do: [:each | each setNormalState].


	activeButton := self tabButtons detect: [:each | each content == self activeContent] ifNone: [^ self].
	activeButton setActiveState.

	self activeContent beActive! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/20/2006 11:16'!
onBoardButtonFired
	<on: fire in: boardButton>

	self player selectBoard! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/22/2006 20:30'!
onExtentChanged
	<on: extentChanged>

	self activeContent ifNil: [^ self].
	self activeContent extent: self contentExtent.! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/17/2006 16:48'!
onLoginButtonFired
	<on: fire in: loginButton>

	self player tryLogin! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/22/2006 20:32'!
onPlayerContentAdded: addedPlayer
	| aButton |
	<on: contentAdded in: player>

	aButton := SqTabButton new 
				content: addedPlayer;
				holder: player;
				label: addedPlayer title;
				yourself.

	self activeContent ifNotNil: [addedPlayer extent: self contentExtent].

	self tabPane add: aButton! !

!SqBoardHolderCostume methodsFor: 'events' stamp: 'minami 3/27/2006 11:54'!
onRestartPlayerButtonFired
	<on: fire in: restartPlayerButton>

	SqClient playAll.
	SqAudioChatUserList allInstancesDo: [:e | e startTileTicking]! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/27/2006 06:04'!
restartPlayerButton
	"Answer the restartPlayerButton of the receiver"
	<bewareOf: #restartPlayerButtonChanged>
	^self propertyValueAt: #restartPlayerButton! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/27/2006 06:04'!
restartPlayerButton: aValue
	"Modify the receiver's restartPlayerButton"
	^self propertyValueAt: #restartPlayerButton put: aValue with: #restartPlayerButtonChanged! !

!SqBoardHolderCostume methodsFor: 'initialize' stamp: 'minami 3/29/2006 15:41'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.
	self layout wrapDirection: #none.

	self addLast: self menuPane.
	self menuPane addLast: self loginButton.	
	self menuPane addLast: self buildSpacer.
	self menuPane addLast: self boardButton.	
	self menuPane addLast: self buildSpacer.
	self menuPane addLast: self restartPlayerButton.	

	self addLast: self tabPane.
	self addLast: self contentHolder.
! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/22/2006 19:55'!
tabButtons
	^ self tabPane collection! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
tabPane
	"Answer the tabPane of the receiver"
	<bewareOf: #tabPaneChanged>
	^self propertyValueAt: #tabPane! !

!SqBoardHolderCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
tabPane: aValue
	"Modify the receiver's tabPane"
	^self propertyValueAt: #tabPane put: aValue with: #tabPaneChanged! !

!SqBoardHolderCostume methodsFor: 'private' stamp: 'minami 3/17/2006 15:53'!
tryLogin
	| userId password client newBoard boardClient boards menuCol selectedUUID tray |

	SqConnectionKeeper default start.

	"RPC"
	userId _ UIManager default request: 'userId?'.
	password _ UIManager default requestPassword: userId, '''s password?'.
	client _ SqClient userId: userId.
	(client login: userId password: password) ifFalse: [^ self error: 'login failed'].

	boards _ client boards.
	menuCol _ boards collect: [:e | Array with: e name with: e boardId].

	menuCol _ {{'create new board...'. UUID nilUUID}}, menuCol.
	selectedUUID _ (SelectionMenu fromArray: menuCol) startUp ifNil: [^ self].
	
	newBoard _ selectedUUID = UUID nilUUID 
		ifTrue: [| bn |
				bn _ UIManager default request: 'new board name?'.
				bn isEmptyOrNil ifTrue: [^ self].
				 client createNewBoard: bn]
		ifFalse: [client boardAt: selectedUUID asUUID].

	"Create BoardClient"
	boardClient _ client enterIn: newBoard.

	"Tweak"
	tray _ SqUIBuilder default boardTrayFor: boardClient.

	self player addContent: tray! !

CPanel subclass: #SqBoardWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardWindow defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="board" toSet="board:" changeEvent="boardChanged">board</field>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="hBar" toSet="hBar:" changeEvent="hBarChanged">hBar</field>
	<field toGet="vBar" toSet="vBar:" changeEvent="vBarChanged">vBar</field>
</fields>'!

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'MU 2/9/2006 15:20'!
on: board 
	^ self new board: board; setDefaultLabel;
		 yourself! !

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'MU 2/9/2006 15:20'!
on: board named: boardName
	^ self new board: board; setLabel: boardName;
		 yourself! !

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'minami 2/8/2006 14:45'!
openOn: board named: boardName 
	^ self new board: board;
		 setLabel: boardName;
		 open;
		 yourself! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'MU 2/9/2006 15:24'!
accessId
	^self board ifNotNilDo: [:b | b accessId]! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 1/16/2006 15:46'!
autoScroll
	| pt |
	pt := self contents globalToLocal: self hand position.
	pt x < 20 ifTrue: [ self scrollLeft].
	((self contents width - 20) < pt x and: [pt x < self contents width]) ifTrue: [self scrollRight].

	pt y < 20 ifTrue: [self scrollUp].
	((self contents height - 20) < pt y and: [pt y < self contents height]) ifTrue: [self scrollDown].! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/27/2005 17:03'!
board
	"Answer the board of the receiver"
	<bewareOf: #boardChanged>
	^self propertyValueAt: #board! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:20'!
boardExtent
	^ self board extent! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'MU 2/9/2006 15:18'!
boardId
	^self board ifNotNilDo: [:b | b boardId]! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/27/2005 17:03'!
board: aValue
	"Modify the receiver's board"
	^self propertyValueAt: #board put: aValue with: #boardChanged! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:32'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:32'!
contents: aValue
	"Modify the receiver's contents"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/15/2006 14:15'!
currentPos
	^ self horizontalPos @ self verticalPos! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/15/2006 14:15'!
currentPos: pos
	self horizontalPos: pos x.
	self verticalPos: pos y.! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'MU 2/10/2006 17:29'!
destroy
	super destroy.
	board ifNotNilDo: [:b | b destroy].
	! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
hBar
	"Answer the hBar of the receiver"
	<bewareOf: #hBarChanged>
	^self propertyValueAt: #hBar! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
hBar: aValue
	"Modify the receiver's hBar"
	^self propertyValueAt: #hBar put: aValue with: #hBarChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:59'!
horizontalPos
	^ self hBar value! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:59'!
horizontalPos: int
	self hBar value: int! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 12/28/2005 12:33'!
initialize
	super initialize.

	self define: #contents as: CScrollPane new.
	self hBar: contents costume hScrollBar.
	self vBar: contents costume vScrollBar.
	! !

!SqBoardWindow methodsFor: 'events' stamp: 'MU 2/10/2006 15:21'!
onWindowCloseRequest
	<on: closeRequest>
	self destroy. "bye, bye"! !

!SqBoardWindow methodsFor: 'copying' stamp: 'minami 1/16/2006 11:44'!
postCopy
	super postCopy.
	self board ifNotNilDo: [:b | b postCopy].! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollDown
	self verticalPos: (self verticalPos + 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollLeft
	self horizontalPos: (self horizontalPos - 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:01'!
scrollRight
	self horizontalPos: (self horizontalPos + 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollUp
	self verticalPos: (self verticalPos - 5)! !

!SqBoardWindow methodsFor: 'scaling' stamp: 'mu 4/3/2006 15:44'!
setBoardScale: aValue

	self board ifNotNilDo: [:b |
		b scale: aValue.
		b globalPosition: b container globalPosition
	]! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'MU 2/9/2006 15:24'!
setDefaultLabel
	self setLabel: self accessId! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 2/23/2006 13:59'!
setLabel: boardName
	self label: ('SqBoard - ' , (boardName asString contractTo: 20))! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 2/22/2006 11:56'!
setupCostume
	super setupCostume.

	self extent: self board extent.
	self layout := CProportionalLayout new.

	contents layoutFrame: (0@0 corner: 1@1).
	contents hResizing: #spaceFill; vResizing: #spaceFill.
	contents hScrollable: true; vScrollable: true.

	self contents add: board.
	self add: contents.

	self extent: 400@300.! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:14'!
smallForm
	^ self board smallForm! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/23/2006 11:55'!
smallForm: reduction
	^ self board smallForm: reduction! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
vBar
	"Answer the vBar of the receiver"
	<bewareOf: #vBarChanged>
	^self propertyValueAt: #vBar! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
vBar: aValue
	"Modify the receiver's vBar"
	^self propertyValueAt: #vBar put: aValue with: #vBarChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 16:00'!
verticalPos
	^ self vBar value! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 16:00'!
verticalPos: int
	self vBar value: int! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:17'!
viewableExtent
	^ self contents extent - (self vBar width @ self hBar height)! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:51'!
viewingPos
	^ self hBar value @ self vBar value! !

Object subclass: #SqRpcClient
	instanceVariableNames: 'rpcConnector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqRpcClient subclass: #SqBoardClient
	instanceVariableNames: 'recordHolder connection isLoggedIn boardDescription authentication accessId eventPlayer eventSender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqBoardClient class methodsFor: 'instance creation' stamp: 'MU 2/10/2006 16:36'!
for: aSqBoardDescription authentication: authentication 
	| inst |
	inst := self new 
				 boardDescription: aSqBoardDescription;
				 authentication: authentication;
				 yourself.
	^ inst! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/25/2006 16:28'!
accessId
	accessId ifNil: [accessId _ SqAccessId 
								userId: self authentication userId
								imageId: SqImageId current
								boardId: self boardDescription boardId].
	^accessId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:17'!
authentication
	^authentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:18'!
authentication: aSqAuthentication 
	authentication := aSqAuthentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:24'!
boardDescription
	^ boardDescription! !

!SqBoardClient methodsFor: 'accessing' stamp: 'mu 3/17/2006 14:16'!
boardDescription: bd
	boardDescription := bd! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/26/2006 17:53'!
boardId
	^ self accessId boardId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 2/8/2006 14:38'!
boardName
	^ self boardDescription boardName! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
closeConnection
	self stopEventSender.
	connection
		ifNotNilDo: [:con | con close].
	connection := nil.
	
	! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:19'!
connection
	connection ifNil: [self ensureConnection].
	^ connection! !

!SqBoardClient methodsFor: 'defaults' stamp: 'MU 1/20/2006 15:19'!
connectionClass
	^ SqExternalConnection! !

!SqBoardClient methodsFor: 'factory' stamp: 'MU 2/8/2006 15:18'!
ensureConnection
	[connection := self connectionClass
				connect: SqSettings serverHost
				to: SqSettings eventListenPort
				returnDo: [:msg | self receiveEvent: msg]
				accessId: self accessId]
		on: RmtNetworkError
		do: [:ex | ex log]! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer
	^eventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer: ep 
	eventPlayer := ep! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:20'!
eventSender
	^eventSender! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:35'!
eventSender: anEventSender
	eventSender _ anEventSender! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 12:28'!
firstEventVersion
	| events |
	events _ self recordHolder events.
	events isEmptyOrNil ifTrue: [^0].
	^events first eventId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 14:01'!
getAllEvents
	^self rpcGetAllEventsOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getEventsFrom: startIndex to: endIndex 
	^ [self
		rpcGetEventsOf: self boardId
		from: startIndex
		to: endIndex]
		on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getLatestEventsFrom: startIndex 
	^ [self rpcGetLatestEventsOf: self boardId from: startIndex] on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 12:07'!
getLatestSnapshot
	^self rpcGetLatestSnapshotOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 3/7/2006 14:50'!
getLatestUpdateSeeds
	| latestSnap snapVersion startVersion alreadyHereVersion paddedEvents  |
	self isLoggedIn ifFalse: [^ nil].

	snapVersion := 0.
	latestSnap := self getLatestSnapshot.
	latestSnap notNil
		ifTrue: [snapVersion := latestSnap second asInteger].
	startVersion _ snapVersion + 1.
	alreadyHereVersion := self firstEventVersion.
	paddedEvents := alreadyHereVersion = 0
				ifTrue: [self getLatestEventsFrom: startVersion]
				ifFalse: [self getEventsFrom: startVersion to: alreadyHereVersion - 1].
	^{latestSnap. paddedEvents}! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:28'!
imageId
	^ self accessId imageId! !

!SqBoardClient methodsFor: 'initialize' stamp: 'MU 2/7/2006 18:32'!
initialize
	super initialize.
	recordHolder  _ connection _ nil.

	isLoggedIn _ false.! !

!SqBoardClient methodsFor: 'testing' stamp: 'MU 1/20/2006 15:19'!
isLoggedIn
	^ isLoggedIn == true
! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 1/20/2006 15:19'!
keepConnection
	self isLoggedIn ifTrue: [
		self connection ifNotNilDo: [:con |
			con isValid ifFalse: [self openConnection].
		].
	]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedIn
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedOut
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
openConnection
	self closeConnection.
	self ensureConnection.
	self startEventSender.
! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 15:17'!
receiveEvent: eventRecord
	self recordHolder add: eventRecord! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 3/2/2006 10:49'!
recordEvent: event
	event displayForDebug: 1.
	self eventSender add: event.
	! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:19'!
recordHolder
	recordHolder ifNil: [recordHolder := SqEventRecordHolder new].
	^ recordHolder! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 11:50'!
registerEventPlayer: aEventPlayer
	self eventPlayer: aEventPlayer.
	self recordHolder addDependent: aEventPlayer.
	! !

!SqBoardClient methodsFor: 'initialize' stamp: 'MU 2/24/2006 11:51'!
release
	super release.
	self closeConnection.
	eventPlayer ifNotNilDo: [:p | p destroy].
	recordHolder ifNotNilDo: [:p | p release].	
	
	eventPlayer _ recordHolder _ connection _ isLoggedIn _ boardDescription _ authentication _ accessId _ nil! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 14:00'!
rpcGetAllEventsOf: boardId
	^self rpcConnector
		invoke: #boardService
		selector: #getAllEventsOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcGetEventsOf: boardId from: startIndex to: endIndex
	^self rpcConnector
		invoke: #boardService
		selector: #getEventsOf:from:to:
		arguments: {boardId. startIndex. endIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 16:18'!
rpcGetLatestEventsOf: boardId from: startIndex
	^self rpcConnector
		invoke: #boardService
		selector: #getLatestEventsOf:from:
		arguments: {boardId. startIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:35'!
rpcGetLatestSnapshotOf: boardId
	^self rpcConnector
		invoke: #boardService
		selector: #getLatestSnapshotOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 3/17/2006 13:02'!
setExtent: extent

	| event  |
	event := SqGenericCommand accessId: self accessId selector: #extent: arguments: {extent}.
	self recordEvent: event.! !

!SqBoardClient methodsFor: 'sending process' stamp: 'MU 3/1/2006 10:35'!
startEventSender
	self stopEventSender.

	self eventSender: (SqEventSender on: self connection).
	self eventSender start.
! !

!SqBoardClient methodsFor: 'sending process' stamp: 'MU 3/1/2006 10:35'!
stopEventSender
	self eventSender ifNotNilDo: [:sender | sender stop].
	self eventSender: nil! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 11:50'!
unregisterEventPlayer: aEventPlayer
	self recordHolder removeDependent: aEventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/27/2006 17:26'!
userId
	^ self accessId userId! !

SqRpcClient subclass: #SqClient
	instanceVariableNames: 'boardClients userId authentication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqClient class
	instanceVariableNames: 'clients'!

!SqClient class methodsFor: 'actions' stamp: 'MU 1/24/2006 12:44'!
addClient: client
	self clients add: client.
	^client! !

!SqClient class methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:00'!
clients
	clients
		ifNil: [clients := Set new].
	^ clients! !

!SqClient class methodsFor: 'actions' stamp: 'MU 2/23/2006 18:33'!
closeAll
	self allInstancesDo: [:e | e close].
	clients := nil! !

!SqClient class methodsFor: 'class initialization' stamp: 'MU 2/23/2006 18:33'!
initialize
	"SqClient initialize"
	self closeAll.
	! !

!SqClient class methodsFor: 'utilities' stamp: 'mu 3/2/2006 10:52'!
playAll
	"SqClient playAll"
	self flag: #toBeDeleted.
	SqUIBuilder default playAll! !

!SqClient class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 13:01'!
userId: idStr 
	| inst detected |
	detected _ self clients detect: [:e | e userId = idStr] ifNone: [].
	detected ifNotNil: [^ detected].

	inst _ self new userId: idStr.
	self clients add: inst.
	^ inst! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:06'!
authentication
	^ authentication! !

!SqClient methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:31'!
boardAt: boardId
	^ self boards
		detect: [:e | e boardId = boardId]
		ifNone: []! !

!SqClient methodsFor: 'accessing' stamp: 'minami 1/23/2006 13:40'!
boardClientAt: boardId
	^ self boardClients at: boardId ifAbsent: []! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 10:23'!
boardClients
	boardClients ifNil: [boardClients _ Dictionary new].
	^ boardClients! !

!SqClient methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:31'!
boardNamed: boardName 
	^ self boards
		detect: [:e | e boardName = boardName]
		ifNone: []! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:29'!
boards
	^ self rpcBoards! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/23/2006 18:32'!
close
	super close.
	self closeConnections! !

!SqClient methodsFor: 'actions' stamp: 'MU 1/20/2006 17:11'!
closeConnections
	self boardClients valuesDo: [:bc |
		bc closeConnection
	].! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:26'!
createNewBoard: boardName
	^ self rpcCreateNewBoard: boardName.

! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/8/2006 14:44'!
enterIn: boardDescription
	| boardClient |
	boardClient _ SqBoardClient for: boardDescription authentication: self authentication.
	boardClient openConnection.
	self boardClients at: boardClient boardId put: boardClient.
	
	boardClient loggedIn.

	^boardClient! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:00'!
imageId
	^ SqImageId current! !

!SqClient methodsFor: 'initialize' stamp: 'MU 2/8/2006 11:36'!
initialize
	super initialize.
	boardClients _ nil.
	authentication _ nil! !

!SqClient methodsFor: 'actions' stamp: 'MU 1/20/2006 17:11'!
keepConnections
	self boardClients valuesDo: [:bc | bc keepConnection].! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/8/2006 11:36'!
login: userId password: passStr
	authentication _ self rpcLogin: userId password: passStr.
	^ authentication notNil! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 17:18'!
logout
	authentication ifNil: [^false].
	^self rpcLogout! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/22/2006 12:29'!
rpcBoards
	^self rpcConnector
		invoke: #boardService
		selector: #boards
		arguments: {}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcCreateNewBoard: boardName 
	^self rpcConnector
		invoke: #boardService
		selector: #createNewBoard:
		arguments: {boardName}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcLogin: userId password: passStr
	^self rpcConnector
		invoke: #loginService
		selector: #login:password:
		arguments: {userId. passStr}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/22/2006 17:14'!
rpcLogout
	^self rpcConnector
		invoke: #loginService
		selector: #logout:
		arguments: {authentication}! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId
	^userId! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId: idStr 
	userId := idStr! !

!SqRpcClient methodsFor: 'actions' stamp: 'MU 2/23/2006 18:30'!
close
	rpcConnector ifNotNilDo: [:con | con close].
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'MU 1/20/2006 15:59'!
initialize
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'printing' stamp: 'MU 2/9/2006 14:41'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	rpcConnector ifNotNilDo: [:con | rpcConnector printOn: aStream].
	aStream nextPutAll: ')'.! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'MU 2/10/2006 15:31'!
release
	rpcConnector ifNotNilDo: [:con | con closeIfOnlyNotPooled].
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:41'!
rpcConnector
	rpcConnector := RmtRpcConnector pooling connect: SqSettings serverHost port: SqSettings rpcListenPort.
	^ rpcConnector! !

Object subclass: #SqUIBuilder
	instanceVariableNames: 'boards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqUIBuilder class
	instanceVariableNames: 'default'!

!SqUIBuilder class methodsFor: 'instance creation' stamp: 'MU 2/8/2006 11:18'!
default
	default ifNil: [default _ self new].
	^default! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'MU 2/9/2006 15:33'!
boards
	boards ifNil: [boards _ WeakSet new].
	^boards! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 3/17/2006 15:52'!
boardTrayFor: boardClient
	"PRE: boardClient is already connected"

	| board tray seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	tray := SqBoardTray on: board.
"
	tray waitTick.
	tray startAudioChat.
"
	^ tray
! !

!SqUIBuilder methodsFor: 'builder' stamp: 'minami 2/27/2006 08:52'!
buildBoardFor: boardClient withSeeds: seeds 
	| snapshot events rawBoard |

	snapshot := seeds first.
	events := seeds second.
	rawBoard := snapshot
				ifNil: [SqEventRecordBoard new]
				ifNotNil: [self buildBoardFromSnapshot: snapshot].
	rawBoard boardClient: boardClient.

	rawBoard elements do: [:each | 
		each eventRecordBehavior ifNotNilDo: [:b |
			each detachEventRecordBehavior.
			each playerId: b targetId.
			rawBoard attachEventRecordBehavior: each.
			each eventRecordBehavior board: rawBoard.
			each eventRecordBehavior targetId: b targetId.
		].
	].

	rawBoard eventPlayer addAllFirst: events.

	rawBoard isRecovering: true. 
	rawBoard play.
	events notEmpty ifTrue: [rawBoard eventPlayer waitUntil: #allEventsExecuted].
	rawBoard isRecovering: false.
	
	self boards add: rawBoard.
	^ rawBoard! !

!SqUIBuilder methodsFor: 'builder' stamp: 'MU 2/24/2006 16:40'!
buildBoardFromSnapshot: snapshot
	| board |
	board _ CPlayer readSnapshotByteArray: snapshot last.
	board ifNil: [^nil].
	board isHeadless: false.
	board eventPlayer: nil.
	^board! !

!SqUIBuilder methodsFor: 'initialize-release' stamp: 'MU 2/9/2006 15:33'!
initialize
	boards _ nil! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 3/10/2006 11:57'!
openBoardTrayFor: boardClient
	"PRE: boardClient is already connected"

	| board tray seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	tray := SqBoardTray on: board.
	tray open.

	tray waitTick.
	tray startAudioChat.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 3/16/2006 08:03'!
openBoardTrayFor: boardClient in: aTray
	"PRE: boardClient is already connected"

	| board seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	aTray setBoard: board.

	aTray waitTick.
	aTray startAudioChat.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'mu 3/10/2006 15:40'!
openBoardWindowFor: boardClient
	"PRE: boardClient is already connected"

	| board win seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	win := SqBoardWindow on: board.
	win open.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'MU 2/8/2006 14:40'!
openBoardWindow: boardDescription userId: userId 
	"PRE: client has been authenticated"
	| client bc |
	client := SqClient userId: userId.
	client
		ifNil: [^ self].
	bc := client boardClientAt: boardDescription boardId.
	bc
		ifNil: [^ self].
	^ self openBoardWindowFor: bc! !

!SqUIBuilder methodsFor: 'utilities' stamp: 'MU 2/9/2006 15:33'!
playAll
	"just workaround"
	"SqUIBuilder default boards"
	"SqUIBuilder default playAll"

	self boards do: [:each | each play]

	
	! !

ElAudioChatClient subclass: #SqAudioChatClient
	instanceVariableNames: 'levelIndicator talkButton userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator
	^ levelIndicator! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator: aPlayer
	levelIndicator := aPlayer! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
startSpeaking
	talkButton
		ifNotNilDo: [:button | button color: Color red].
	super startSpeaking! !

!SqAudioChatClient methodsFor: 'running' stamp: 'minami 3/7/2006 16:39'!
stop
	super stop.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
stopSpeaking
	super stopSpeaking.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton
	^ talkButton! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton: aButton
	talkButton := aButton! !

!SqAudioChatClient methodsFor: 'private ui' stamp: 'minami 3/15/2006 19:22'!
uiUpdateLevel: anInteger
	levelIndicator ifNil: [^ self].
	levelIndicator level: (anInteger / 16r8000) asFloat! !

!SqAudioChatClient methodsFor: 'private ui' stamp: 'minami 3/15/2006 19:22'!
uiUpdateSpeakers: speakers listeners: listeners
	self userList ifNotNilDo: [ :ul | ul speakers: speakers listeners: listeners ].
! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/8/2006 12:03'!
userList
	^ userList! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/8/2006 12:03'!
userList: aList
	userList := aList! !

!CHalo methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/10/2006 12:04'!
handleSpecs
	"Answer specs defining the halo handles to use."

	^ Preferences debugHaloHandle
	 	ifFalse:
			[{{#haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.5.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.5.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.5.		Color cyan. 'v'. 	'Open Viewer'	}}]
		ifTrue:
			[{{ #haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.66667.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.66667.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloDebug.  1.0.		0.33333.		Color cyan muchLighter. 'D'. 'Debug'}.
			{ #haloTile.      0.0.		0.25.	Color orange.	 't'.		'Tile'			}.
			{ #haloLink.     0.0.		0.5.		Color palePeach.	 'l'.		'Link'			}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 		 'r'.		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.75.	Color cyan. 		 'v'. 	'Open Viewer'	}}]
	! !

!CHalo methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/27/2006 07:38'!
onSelectTarget
	| index list cc aHand boardPos |
	aHand := self hand.
	list := aHand playersUnder: aHand world.
	list isEmpty ifTrue:[^self].
"list inspect."
	boardPos := list findLast: [:e | e player findPlayerOf: SqEventRecordBoard].
	boardPos >= 2 ifTrue: [
		list :=  (list allButFirst: boardPos), (list first: boardPos) reverse, {list last}.
	].
"list inspect."
	cc := self target ifNotNil:[self target asPrimCostume].
	index := list identityIndexOf: (cc ifNil:[self rootContext]).
	index = 0 ifTrue:[
		aHand shiftPressed 
			ifTrue:[index := 1]
			ifFalse:[index := list size - 1]
	] ifFalse:[
		aHand shiftPressed
			ifTrue:[index := index+1]
			ifFalse:[index := index-1].
	].
	"@@@@: Fix this. Later figure out how to wrap and ask guys for interest"
	self target: (list atWrap: index) asPlayer haloTarget! !

ApplicationService subclass: #SqEventSender
	instanceVariableNames: 'connection eventQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqEventSender class methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:23'!
defaultPriority

	^Processor lowIOPriority! !

!SqEventSender class methodsFor: 'instance creation' stamp: 'minami 2/28/2006 15:58'!
on: aConnection
	^ self new connection: aConnection; yourself! !

!SqEventSender methodsFor: 'adding' stamp: 'minami 2/28/2006 16:39'!
add: aEvent
	self eventQueue nextPut: aEvent! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection
	^ connection! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection: aConnection
	connection := aConnection! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 16:36'!
eventQueue
	^ eventQueue! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:12'!
initialize
	super initialize.

	eventQueue := SharedQueue2 new: 100.

	! !

!SqEventSender methodsFor: 'testing' stamp: 'mu 3/8/2006 11:15'!
isValid
	self connection
		ifNil: [^ false].
	^ self connection isValid! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/10/2006 16:57'!
release
	self unregister.! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/10/2006 16:56'!
releaseQueue
	eventQueue ifNotNilDo: [:q | q release].
! !

!SqEventSender methodsFor: 'running' stamp: 'mu 3/8/2006 11:16'!
runWhile: aBlock
	[aBlock value and:[self isValid]] 
		whileTrue: [self send]! !

!SqEventSender methodsFor: 'actions' stamp: 'mu 3/17/2006 12:00'!
send
	| event |
	event _ self eventQueue next.
	event
		ifNil: [^ self].
	self eventQueue size = 0
		ifTrue: [self connection send: event]
		ifFalse: [self connection deferSend: event]! !

!SqEventSender methodsFor: 'running' stamp: 'mu 3/10/2006 16:56'!
stop
	super stop.
	self releaseQueue! !

ElClient subclass: #SqAudioChatFacade
	instanceVariableNames: 'userList board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

!SqAudioChatFacade class methodsFor: 'instance creation' stamp: 'minami 3/9/2006 14:33'!
on: board 
	^ self new board: board;
		 yourself! !

!SqAudioChatFacade class methodsFor: 'defaults' stamp: 'minami 3/16/2006 17:14'!
serverAddress
	^ NetNameResolver addressForName: SqSettings audioChatServerHost.
! !

!SqAudioChatFacade methodsFor: 'defaults' stamp: 'minami 3/7/2006 15:22'!
audioChatClientClass
	^ Smalltalk at: #SqAudioChatClient! !

!SqAudioChatFacade methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:33'!
board
	^ board! !

!SqAudioChatFacade methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:33'!
board: aBoard
	board := aBoard! !

!SqAudioChatFacade methodsFor: 'initialize' stamp: 'minami 3/9/2006 10:43'!
initialize
	id := SqImageId current.
	monitor := Monitor new.
	self isRunning: false.
	logOnOk := false.
	dictionary := Dictionary new.
	dictionaryMutex := Semaphore forMutualExclusion.
	commandClient := self commandClientClass
		on: self
		id: id
		address: self class serverAddress
		port: self class commandPort.
	chatClient := self audioChatClientClass
		on: self
		id: id
		address: self class serverAddress
		port: self class chatPort.
! !

!SqAudioChatFacade methodsFor: 'private' stamp: 'minami 3/7/2006 19:01'!
isRunning: bool
	isRunning := bool.
	self signal: #isRunningChanged with: bool! !

!SqAudioChatFacade methodsFor: 'running' stamp: 'minami 3/16/2006 17:08'!
start
	monitor critical: [
		self isRunning ifTrue: [ ^ self ].
		[
			logOnOk := false.

			uname := self board userId.
			(uname isNil or: [ uname isEmpty ]) ifTrue: [ self isRunning: false. ^ self ].
			commandClient start.
			self tryLoggingOn ifFalse: [ PopUpMenu inform: 'Cannot login'. ^ self stop. ].
			chatClient start.
			self isRunning: true.
		] ifCurtailed: [
			self stop.
		].
	].
! !

!SqAudioChatFacade methodsFor: 'private' stamp: 'minami 3/10/2006 16:18'!
tryLoggingOn
	self sendLogOnCommandGroup: self board boardId.
	monitor waitFor: #LogOnOk maxSeconds: 5.
	^ logOnOk.
! !

!SqAudioChatFacade methodsFor: 'ui common' stamp: 'minami 3/16/2006 07:25'!
uiAddUserId: userId name: nickname
	userList ifNil: [^ nil].
	userList addUserId: userId nickname: nickname.
! !

!SqAudioChatFacade methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:25'!
userList
	^ userList! !

!SqAudioChatFacade methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:25'!
userList: aUserList
	userList := aUserList! !

SqTabHolder subclass: #SqBoardHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardHolder defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="client" toSet="client:" changeEvent="clientChanged">client</field>
</fields>'!

!SqBoardHolder methodsFor: 'adding' stamp: 'minami 3/17/2006 14:45'!
addTray: aTray
	self addContent: aTray! !

!SqBoardHolder methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:11'!
client
	"Answer the client of the receiver"
	<bewareOf: #clientChanged>
	^self propertyValueAt: #client! !

!SqBoardHolder methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:11'!
client: aValue
	"Modify the receiver's client"
	^self propertyValueAt: #client put: aValue with: #clientChanged! !

!SqBoardHolder methodsFor: 'initialize' stamp: 'minami 3/17/2006 15:30'!
defaultCostume

	^ SqBoardHolderCostume! !

!SqBoardHolder methodsFor: 'initialize' stamp: 'minami 3/23/2006 07:45'!
destroy
	self logout.
	self client close.
	super destroy! !

!SqBoardHolder methodsFor: 'private' stamp: 'minami 3/27/2006 11:45'!
selectBoard

	| boards menuCol selectedUUID newBoard boardClient tray existed |

	client ifNil: [^ self].

	boards _ client boards.
	menuCol _ boards collect: [:e | Array with: e name with: e boardId].

	menuCol _ {{'create new board...'. UUID nilUUID}}, menuCol.
	selectedUUID _ (SelectionMenu fromArray: menuCol) startUp ifNil: [^ self].
	
	newBoard _ selectedUUID = UUID nilUUID 
		ifTrue: [| bn |
				bn _ UIManager default request: 'new board name?'.
				bn isEmptyOrNil ifTrue: [^ self].
				 client createNewBoard: bn]
		ifFalse: [client boardAt: selectedUUID asUUID].


	existed _ self costume tabButtons detect: [:each | each content boardId = newBoard boardId] ifNone: [].
	existed ifNotNilDo: [:button | ^ button onFired].

	"Create BoardClient"
	boardClient _ client enterIn: newBoard.

	"Tweak"
	tray _ SqUIBuilder default boardTrayFor: boardClient.

	self addContent: tray.
	self activeContent: tray.! !

!SqBoardHolder methodsFor: 'content access' stamp: 'minami 3/22/2006 20:18'!
setActiveContent: aPlayer
	
	| myExtent |

	myExtent := self extent.
	self activeContent: aPlayer.

	self waitTick.
	self extent: myExtent.! !

!SqBoardHolder methodsFor: 'private' stamp: 'minami 3/23/2006 07:47'!
tryLogin
	| userId password sqClient |

	self client ifNotNil: [^ UIManager default inform: 'already login'].


	SqConnectionKeeper default start.

	"RPC"
	userId := UIManager default request: 'userId?'.
	password := UIManager default requestPassword: userId, '''s password?'.
	sqClient := SqClient userId: userId.
	(sqClient login: userId password: password) ifFalse: [
		client := nil.
		^ self error: 'login failed'
	].

	client := sqClient
! !

TdTimer subclass: #SqSquareDiscovery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-Discovery'!

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:03'!
defaultIntervalSeconds
	^ 15! !

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:03'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqSquareDiscovery class methodsFor: 'class initialization' stamp: 'mu 3/27/2006 14:37'!
initialize
	"SqSquareDiscovery initialize"
	self default start! !

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:32'!
serviceType
	^'SqSquare'! !

!SqSquareDiscovery methodsFor: 'actions' stamp: 'mu 3/31/2006 11:41'!
perform
	SqSettings useDiscovery ifFalse: [^self].
	self setServerLocations! !

!SqSquareDiscovery methodsFor: 'actions' stamp: 'mu 3/27/2006 15:17'!
setServerLocations
	| locator boardServices chatServices  |
	locator _ DsLocator defaultForBroadcast.
	boardServices := (locator
				servicesMatches: [:ent | ent type = self class serviceType
						and: [ent name = 'BoardService']]) asSortedCollection.
	boardServices
		ifNotEmptyDo: [:services | SqSettings serverHost: services first host].

	
	chatServices := (locator
				servicesMatches: [:ent | ent type = self class serviceType
						and: [ent name = 'ChatService']]) asSortedCollection.
	chatServices
		ifNotEmptyDo: [:services | SqSettings audioChatServerHost: services first host]! !

!CProjectBuilder class methodsFor: '*SqSquare-Client-notes' stamp: 'mu 3/27/2006 16:25'!
sqSquareReleaseNotes 
"
	(Workspace new) contents: self sqSquareReleaseNotes; openLabel: ''
"


	^ '- How to start SqSquare -

*On server:
 "Create a board"
 SqExample createBoardOnServer.

*On client:
 SqBoardHolder open.

If you do it, login dialog will open. You can enter ''user01'' from ''user10''. 
(password is the same as userId).

Select ''board1''. You can see two windows. One is a map for the whole screen,
and the other is your local view.


*Settings
 "To reset board''s contents:"
 SqServer forgetAll; deleteAll.

 "To show debug messages:"
 SqSettings isDebugging: true.

' ! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo-menu' stamp: 'MU 2/17/2006 13:23'!
getLinkForPlayer: target
	target linkForSelf openInHand.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'mu 3/2/2006 10:19'!
initialize
	super initialize.
	self allProjects: CCollection new.
	projectShell := self projectShellClass new.
	projectList := self newProjectList.
	self newProject.
	worldMenu := CMenuBar new. "will be clobbered immediately"
	self startScript: #installWorldMenu.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/17/2006 16:21'!
onHaloDrag: aHandle
	| lastPt nextPt delta haloTarget oldPos |
	<on: haloDrag>
	"note: does not recompute transform every frame"
	lastPt := self hand position. "global!!"
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	oldPos := haloTarget position.
	self trackHaloHandle: aHandle in:[
		nextPt := self hand position. "global!!"
		haloTarget container 
			ifNil:[delta := nextPt - lastPt]
			ifNotNil:[delta := (haloTarget container globalToLocal: nextPt) - 
					(haloTarget container globalToLocal: lastPt)].
		haloTarget costume moveBy: delta.
		lastPt := nextPt.
	].
	haloTarget tweaked: #position from: oldPos to: haloTarget position.

	haloTarget signal: #haloDragFinished! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 17:01'!
onHaloEvent: aHandle
	| eventName |
	<on: haloEvent in: halo>
	eventName := aHandle value.
	self halo target ifNil:[^self].
	eventName ifNil:[^self].
	self signal: eventName with: aHandle.

	self halo target signal: eventName.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 14:37'!
onHaloGrab: aHandle
	| haloTarget parent aHand |
	<on: haloGrab>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	parent := haloTarget container.
	haloTarget transform: haloTarget localToWorld.

	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	parent asPrimCostume tweaked: #contents after:[
		haloTarget world add: haloTarget.
	].
	aHand := aHandle hand.
	halo elements do:[:each| each visible: each == aHandle].
	aHand releaseMouseFocus: aHandle.
	aHandle locked: true.
	haloTarget startScript: #onDrag.
	aHand waitUntil: #mouseUp.
	aHandle locked: false.
	halo elements do:[:each| each visible: true].

	haloTarget signal: #haloGrabFinished
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'MU 2/13/2006 16:16'!
onHaloLink: aHandle
	"The user has clicked on the hand-me-a-tile halo handle of an object"

	<on: haloLink>
	self getLinkForPlayer: self halo target! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 2/8/2006 01:11'!
onHaloRepaint: aHandle
	| haloTarget painter aForm bForm |
	<on: haloRepaint>
	painter := self makeNewPainter: 32.
	haloTarget := self halo target.
	haloTarget visible: false.
	painter target: haloTarget.
	painter waitUntil: #close.
	projectShell tool: nil.
	haloTarget visible: true.

	aForm := haloTarget graphicForm.
	aForm ifNil: [^ self].

	aForm island == haloTarget island ifFalse:[
		bForm := haloTarget island new: Form 
			constructor: #extent:depth: 
			arguments:{aForm extent. aForm depth}.
		aForm displayOn: bForm.
		haloTarget graphicForm: bForm.
	].
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initializing' stamp: 'minami 1/20/2006 12:23'!
projectShellClass
	^ CProjectShell! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/27/2006 11:17'!
showInitialStuff
	self waitTick; waitTick.

"
	self showLicense window moveBy: -10@-40.
	self showReleaseNotes window moveBy: 10@40.
"
	SqSettings showReleaseNotes ifTrue: [
		self showSqSquareReleaseNotes window moveBy: 40@0.
	]! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initial window' stamp: 'mu 3/2/2006 10:34'!
showSqSquareReleaseNotes
	| ws |
	ws := projectShell myIsland new: CWorkspace.
	"tricky... need to create text in project's island"
	ws contents: (ws send: #sqSquareReleaseNotes to: self class).
	ws extent: 500@400.
	self waitTick.
	ws openCenteredIn: projectShell projectWorld.
	ws label: 'SqSquare'.
	^ws! !

CPlayer subclass: #SqAudioChatPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="client" toSet="client:" changeEvent="clientChanged">client</field>
</fields>'!

!SqAudioChatPlayer class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 18:28'!
client: client
	^ super new client: client; yourself! !

!SqAudioChatPlayer methodsFor: 'private accessing' stamp: 'minami 3/9/2006 12:36'!
chatClient
	self client ifNil: [^ nil].
	^ self client chatClient! !

!SqAudioChatPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 18:28'!
client
	"Answer the client of the receiver"
	<bewareOf: #clientChanged>
	^self propertyValueAt: #client! !

!SqAudioChatPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 18:28'!
client: aValue
	"Modify the receiver's client"
	^self propertyValueAt: #client put: aValue with: #clientChanged! !

!SqAudioChatPlayer methodsFor: 'private accessing' stamp: 'minami 3/9/2006 12:36'!
commandClient
	self client ifNil: [^ nil].
	^ self client commandClient! !

!SqAudioChatPlayer methodsFor: 'initialize' stamp: 'minami 3/7/2006 18:46'!
defaultCostume
	^ SqAudioChatCostume! !

!SqAudioChatPlayer methodsFor: 'initialize' stamp: 'minami 3/15/2006 03:00'!
destroy
	self stop.
	super destroy.! !

!SqAudioChatPlayer methodsFor: 'testing' stamp: 'minami 3/9/2006 14:07'!
isRunning
	self client ifNil: [^ false].
	^ self client isRunning! !

!SqAudioChatPlayer methodsFor: 'running' stamp: 'minami 3/9/2006 14:08'!
start
	self client ifNil: [^ self].
	self client start! !

!SqAudioChatPlayer methodsFor: 'running' stamp: 'minami 3/23/2006 08:02'!
stop
	self client stop.

	self costume userList removeAll! !

CPlayer subclass: #SqAudioChatUserList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatUserList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/16/2006 07:36'!
addUserId: id nickname: nickname
	| detected |
	detected := self costume contents detect: [:each | each player id = id] ifNone: [].
	detected ifNotNil: [^ self].
	self add: (SqAudioChatUserTile id: id nickname: nickname).
! !

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:42'!
initialize
	super initialize! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/15/2006 19:18'!
removeAll
	[self userTiles size > 0]
		whileTrue: [self removeLast].
	self extent: 0@0.! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/7/2006 17:14'!
removeId: id
	| detected |
	detected := self costume contents detect: [:tile | tile id = id] ifNone: [].
	detected ifNotNil: [self remove: detected].
	! !

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/8/2006 11:13'!
setupCostume
	super setupCostume.
	self extent: 0@0.
	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.
! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/16/2006 07:30'!
speakers: speakers listeners: listeners
	self userTiles do: [ :tile |
		tile speaking: (speakers includes: tile id).
		tile listening: (listeners includes: tile id).
	].
! !

!SqAudioChatUserList methodsFor: 'running' stamp: 'minami 3/15/2006 19:22'!
startTileTicking
	self userTiles do: [:each | each start].! !

!SqAudioChatUserList methodsFor: 'running' stamp: 'minami 3/15/2006 19:18'!
stopTileTicking
	self userTiles do: [:each | each stop].! !

!SqAudioChatUserList methodsFor: 'private' stamp: 'minami 3/15/2006 19:17'!
userTiles
	^ self collection! !

CPlayer subclass: #SqAudioChatUserTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatUserTile defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="id" toSet="id:" changeEvent="idChanged">id</field>
	<field toGet="nickname" toSet="nickname:" changeEvent="nicknameChanged">nickname</field>
	<field toGet="speaking" toSet="speaking:" changeEvent="speakingChanged">speaking</field>
	<field toGet="listening" toSet="listening:" changeEvent="listeningChanged">listening</field>
	<field toGet="speakingLamp" toSet="speakingLamp:" changeEvent="speakingLampChanged">speakingLamp</field>
	<field toGet="listeningLamp" toSet="listeningLamp:" changeEvent="listeningLampChanged">listeningLamp</field>
	<field toGet="nameLabel" toSet="nameLabel:" changeEvent="nameLabelChanged">nameLabel</field>
</fields>'!

!SqAudioChatUserTile class methodsFor: 'instance creation' stamp: 'minami 3/8/2006 16:20'!
id: id 
	^ self id: id nickname: id! !

!SqAudioChatUserTile class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 17:02'!
id: id nickname: nickname 
	^ self new id: id;
		 nickname: nickname;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/8/2006 11:35'!
colorOf: aBoolean 
	^ aBoolean
		ifTrue: [Color red]
		ifFalse: [Color gray]! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:51'!
createNewLamp
	^ CPlayer new color: Color lightGray;
		 extent: 8 @ 8;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 19:30'!
defaultBackgroundColor
	^ Color white! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 16:58'!
defaultExtent
	^ 120@16! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id
	"Answer the id of the receiver"
	<bewareOf: #idChanged>
	^self propertyValueAt: #id! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id: aValue
	"Modify the receiver's id"
	^self propertyValueAt: #id put: aValue with: #idChanged! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/15/2006 19:25'!
initialize
	super initialize.

	speaking := listening := false.
! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
listening
	"Answer the listening of the receiver"
	<bewareOf: #listeningChanged>
	^self propertyValueAt: #listening! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp
	"Answer the listeningLamp of the receiver"
	<bewareOf: #listeningLampChanged>
	^self propertyValueAt: #listeningLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp: aValue
	"Modify the receiver's listeningLamp"
	^self propertyValueAt: #listeningLamp put: aValue with: #listeningLampChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
listening: aValue
	"Modify the receiver's listening"
	^self propertyValueAt: #listening put: aValue with: #listeningChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel
	"Answer the nameLabel of the receiver"
	<bewareOf: #nameLabelChanged>
	^self propertyValueAt: #nameLabel! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel: aValue
	"Modify the receiver's nameLabel"
	^self propertyValueAt: #nameLabel put: aValue with: #nameLabelChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname
	"Answer the nickname of the receiver"
	<bewareOf: #nicknameChanged>
	^self propertyValueAt: #nickname! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname: aValue
	"Modify the receiver's nickname"
	^self propertyValueAt: #nickname put: aValue with: #nicknameChanged! !

!SqAudioChatUserTile methodsFor: 'events' stamp: 'minami 3/8/2006 12:14'!
onTick
	speakingLamp color: (self colorOf: self speaking).
	listeningLamp color: (self colorOf: self listening).
	speaking := false.
	listening := false.
! !

!SqAudioChatUserTile methodsFor: 'openning' stamp: 'minami 3/8/2006 15:09'!
open
	super open.
	self postOpen.! !

!SqAudioChatUserTile methodsFor: 'openning' stamp: 'minami 3/8/2006 15:09'!
postOpen
	self start! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/8/2006 11:53'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.

	self extent: self defaultExtent.
	self color: self defaultBackgroundColor.
	self borderWidth: 1.
	self borderColor: Color black.	

	self listeningLamp: self createNewLamp.
	self add: self listeningLamp.

	self addSpacer: 2@8.

	self speakingLamp: self createNewLamp.
	self add: self speakingLamp.

	self addSpacer: 2@8.

	self nameLabel: (CLabel new label: self nickname; yourself).
	self add: self nameLabel.
! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
speaking
	"Answer the speaking of the receiver"
	<bewareOf: #speakingChanged>
	^self propertyValueAt: #speaking! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp
	"Answer the speakingLamp of the receiver"
	<bewareOf: #speakingLampChanged>
	^self propertyValueAt: #speakingLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp: aValue
	"Modify the receiver's speakingLamp"
	^self propertyValueAt: #speakingLamp put: aValue with: #speakingLampChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
speaking: aValue
	"Modify the receiver's speaking"
	^self propertyValueAt: #speaking put: aValue with: #speakingChanged! !

!SqAudioChatUserTile methodsFor: 'running' stamp: 'minami 3/15/2006 19:27'!
start
	self stop.
	self startTicking: #onTick at: 2! !

!SqAudioChatUserTile methodsFor: 'running' stamp: 'minami 3/8/2006 12:22'!
stop
	self stopScript: #onTick! !

CPlayer subclass: #SqBoardMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardMap defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="boardImage" toSet="boardImage:" changeEvent="boardImageChanged">boardImage</field>
	<field toGet="clientBoard" toSet="clientBoard:" changeEvent="clientBoardChanged">clientBoard</field>
	<field toGet="cursorPos" toSet="cursorPos:" changeEvent="cursorPosChanged">cursorPos</field>
	<field toGet="cursorExtent" toSet="cursorExtent:" changeEvent="cursorExtentChanged">cursorExtent</field>
	<field toGet="hBar" toSet="hBar:" changeEvent="hBarChanged">hBar</field>
	<field toGet="vBar" toSet="vBar:" changeEvent="vBarChanged">vBar</field>
	<field toGet="reductionRatio" toSet="reductionRatio:" changeEvent="reductionRatioChanged">reductionRatio</field>
</fields>'!

!SqBoardMap class methodsFor: 'instance creation' stamp: 'minami 2/22/2006 16:53'!
for: clientBoard 
	^ self new
		 clientBoard: clientBoard;
		 hBar: clientBoard scroller hBar;
		 vBar: clientBoard scroller vBar;
		 onClientBoardGeometryChanged;
		 onVBarValueChanged;
		 onHBarValueChanged;
		 yourself! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 3/17/2006 16:13'!
boardImage
	"Answer the boardImage of the receiver"
	<bewareOf: #boardImageChanged>
	^self propertyValueAt: #boardImage! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 3/17/2006 16:13'!
boardImage: aValue
	"Modify the receiver's boardImage"
	^self propertyValueAt: #boardImage put: aValue with: #boardImageChanged! !

!SqBoardMap methodsFor: 'private' stamp: 'mu 3/16/2006 17:17'!
calculateReductionRatio: boardExtent
	| newRatio |
	newRatio := (boardExtent x max: boardExtent y) // self maxLength.
	self reductionRatio = newRatio ifTrue: [^ self].
	newRatio = 0 ifTrue: [newRatio := 1].
	^ self reductionRatio: newRatio! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 3/17/2006 16:20'!
clearBoardImage
	self boardImage: nil.! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:43'!
clientBoard
	"Answer the clientBoard of the receiver"
	<bewareOf: #clientBoardChanged>
	^self propertyValueAt: #clientBoard! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:43'!
clientBoard: aValue
	"Modify the receiver's clientBoard"
	^self propertyValueAt: #clientBoard put: aValue with: #clientBoardChanged! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 12/27/2005 16:02'!
cursorColor
	^ Color red! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:44'!
cursorExtent
	"Answer the cursorExtent of the receiver"
	<bewareOf: #cursorExtentChanged>
	^self propertyValueAt: #cursorExtent! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:44'!
cursorExtent: aValue
	"Modify the receiver's cursorExtent"
	^self propertyValueAt: #cursorExtent put: aValue with: #cursorExtentChanged! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 15:58'!
cursorPos
	"Answer the cursorPos of the receiver"
	<bewareOf: #cursorPosChanged>
	^self propertyValueAt: #cursorPos! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 15:58'!
cursorPos: aValue
	"Modify the receiver's cursorPos"
	^self propertyValueAt: #cursorPos put: aValue with: #cursorPosChanged! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 2/23/2006 11:57'!
defaultWidth
	^ 150! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 3/17/2006 16:22'!
drawOn: aCanvas in: drawingBounds
	aCanvas drawImage: self latestBoardImage at: 0@0.
	aCanvas frameRectangle: (cursorPos extent: cursorExtent) color: self cursorColor.! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
hBar
	"Answer the hBar of the receiver"
	<bewareOf: #hBarChanged>
	^self propertyValueAt: #hBar! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
hBar: aValue
	"Modify the receiver's hBar"
	^self propertyValueAt: #hBar put: aValue with: #hBarChanged! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 3/17/2006 16:21'!
hide
	self visible: false.
	self clearBoardImage! !

!SqBoardMap methodsFor: 'initialize' stamp: 'minami 2/23/2006 11:56'!
initialize
	super initialize.
	cursorPos := 0@0.
	cursorExtent := 0@0.
	
	reductionRatio := 5.
	
	self setupCostume.

! !

!SqBoardMap methodsFor: 'testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ false.! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 3/17/2006 16:16'!
latestBoardImage
	self boardImage ifNil: [self boardImage: (self clientBoard smallForm: self reductionRatio)].
	^ self boardImage! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 2/23/2006 12:06'!
maxLength
	^ 150! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 2/22/2006 17:00'!
moveBoardView
	clientBoard scroller horizontalPos: (self cursorPos x * self reductionRatio) asInteger.
	clientBoard scroller verticalPos: (self cursorPos y * self reductionRatio) asInteger.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 2/23/2006 12:17'!
onClientBoardDestroyed
	<on: destroy in: clientBoard>

	self destroy.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:24'!
onClientBoardGeometryChanged
	<on: geometryChanged in: clientBoard>

	self clearBoardImage.

	self calculateReductionRatio: clientBoard extent.

	self extent: (clientBoard extent // self reductionRatio).
	self cursorExtent: (clientBoard viewPort extent // self reductionRatio).
	self invalidate.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:24'!
onClientBoardLayoutChanged
	<on: layoutChanged in: clientBoard>

	self clearBoardImage.

	self extent: (clientBoard extent // self reductionRatio).
	self cursorExtent: (clientBoard viewPort extent // self reductionRatio).
	self invalidate.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 2/22/2006 17:01'!
onHBarValueChanged
	<on: valueChanged in: hBar>
	self cursorPos: ((hBar value // self reductionRatio) @ self cursorPos y) asIntegerPoint.
	self invalidate.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:26'!
onMouseEnter
	<on: mouseEnter>

	self mouseCursor: CCursorLibrary handCursor.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:26'!
onMouseMove
	<on: mouseMove>

	self mouseCursor: CCursorLibrary handCursor.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/29/2006 19:41'!
onRedButtonDown
	<on: redButtonDown>

	self clearBoardImage.

	self trailBoardView! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/29/2006 19:41'!
onRedButtonMove
	<on: redButtonMove>
	self trailBoardView! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:24'!
onRedButtonUp
	<on: redButtonUp>

	self clearBoardImage.

	self mouseCursor: CCursorLibrary handCursor.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 2/22/2006 17:01'!
onVBarValueChanged
	<on: valueChanged in: vBar>
	self cursorPos: (self cursorPos x @ (vBar value // self reductionRatio)) asIntegerPoint.
	self invalidate.! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 2/22/2006 17:02'!
reductionRatio
	"Answer the reductionRatio of the receiver"
	<bewareOf: #reductionRatioChanged>
	^self propertyValueAt: #reductionRatio! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 2/22/2006 17:02'!
reductionRatio: aValue
	"Modify the receiver's reductionRatio"
	^self propertyValueAt: #reductionRatio put: aValue with: #reductionRatioChanged! !

!SqBoardMap methodsFor: 'initialize' stamp: 'minami 12/27/2005 15:10'!
setupCostume
	self userDraw: true.
! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 3/9/2006 17:04'!
show
	self visible: true! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 3/29/2006 19:40'!
trailBoardView
	| topLeftPos newPos |
	self mouseCursor: CCursorLibrary fistCursor.

	topLeftPos := self globalToLocal: self hand position.
	newPos := topLeftPos - (self cursorExtent // 2).
	self cursorPos: newPos.

	self moveBoardView.
	self invalidate! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
vBar
	"Answer the vBar of the receiver"
	<bewareOf: #vBarChanged>
	^self propertyValueAt: #vBar! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
vBar: aValue
	"Modify the receiver's vBar"
	^self propertyValueAt: #vBar put: aValue with: #vBarChanged! !

CPlayer subclass: #SqBoardTray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardTray defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="boardHolder" toSet="boardHolder:" changeEvent="boardHolderChanged">boardHolder</field>
	<field toGet="audioChatPlayer" toSet="audioChatPlayer:" changeEvent="audioChatPlayerChanged">audioChatPlayer</field>
	<field toGet="controllerPane" toSet="controllerPane:" changeEvent="controllerPaneChanged">controllerPane</field>
	<field toGet="board" toSet="board:" changeEvent="boardChanged">board</field>
	<field toGet="settingsButton" toSet="settingsButton:" changeEvent="settingsButtonChanged">settingsButton</field>
</fields>'!

!SqBoardTray class methodsFor: 'instance creation' stamp: 'minami 3/9/2006 14:46'!
on: aBoard 
	^ self new setBoard: aBoard;
		 yourself! !

!SqBoardTray methodsFor: 'menu' stamp: 'mu 3/17/2006 15:45'!
addExtentMenuOn: aMenu
	| menu |
	menu := CMenu new.
	menu add: '800x600' target: board action: #setExtent: argument: 800@600.
	menu add: '1600x1200' target: board action: #setExtent: argument: 1600@1200.
	menu add: '2400x1800' target: board action: #setExtent: argument: 2400@1800.
	menu add: '3200x2400' target: board action: #setExtent: argument: 3200@2400.
	menu add: '4000x3000' target: board action: #setExtent: argument: 4000@3000.	
	menu add: 'other...' action: [board setExtent: (Point readFrom: (FillInTheBlank request: 'extent? x@y'))].	
	aMenu add: 'Extent' subMenu: menu.
	^aMenu! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:14'!
audioChatPlayer
	"Answer the audioChatPlayer of the receiver"
	<bewareOf: #audioChatPlayerChanged>
	^self propertyValueAt: #audioChatPlayer! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:14'!
audioChatPlayer: aValue
	"Modify the receiver's audioChatPlayer"
	^self propertyValueAt: #audioChatPlayer put: aValue with: #audioChatPlayerChanged! !

!SqBoardTray methodsFor: 'actions' stamp: 'minami 3/23/2006 07:56'!
beActive
	self startAudioChat! !

!SqBoardTray methodsFor: 'actions' stamp: 'minami 3/23/2006 07:56'!
beBackground
	self stopAudioChat! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:49'!
board
	"Answer the board of the receiver"
	<bewareOf: #boardChanged>
	^self propertyValueAt: #board! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 11:44'!
boardHolder
	"Answer the boardHolder of the receiver"
	<bewareOf: #boardHolderChanged>
	^self propertyValueAt: #boardHolder! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 11:44'!
boardHolder: aValue
	"Modify the receiver's boardHolder"
	^self propertyValueAt: #boardHolder put: aValue with: #boardHolderChanged! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/22/2006 20:26'!
boardId
	^ self board boardId! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:49'!
board: aValue
	"Modify the receiver's board"
	^self propertyValueAt: #board put: aValue with: #boardChanged! !

!SqBoardTray methodsFor: 'private' stamp: 'minami 3/9/2006 14:54'!
buildAudioChatPlayer
	^ SqAudioChatPlayer new.! !

!SqBoardTray methodsFor: 'private' stamp: 'minami 3/9/2006 16:38'!
buildBoardHolder
	| holder |
	holder := CScrollPane new.

	holder hResizing: #spaceFill; vResizing: #spaceFill.
	holder hScrollable: true; vScrollable: true.
	holder color: self defaultBackgroundColor.

	holder costume: SqScrollPaneCostume new.

	^ holder
! !

!SqBoardTray methodsFor: 'private' stamp: 'minami 3/9/2006 14:21'!
buildControllerPane
	| aPane |
	aPane := CPlayer new.

	aPane layout: CTableLayout new.
	aPane hResizing: #rigit; vResizing: #spaceFill.
	aPane layout listDirection: #topToBottom.
	aPane color: self defaultBackgroundColor.

	^ aPane
! !

!SqBoardTray methodsFor: 'private' stamp: 'mu 3/17/2006 14:48'!
buildSettingsButton
	^ CButton new label: 'settings';
		 hResizing: #spaceFill;
		 vResizing: #rigit;
		 yourself! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:17'!
controllerPane
	"Answer the controllerPane of the receiver"
	<bewareOf: #controllerPaneChanged>
	^self propertyValueAt: #controllerPane! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:17'!
controllerPane: aValue
	"Modify the receiver's controllerPane"
	^self propertyValueAt: #controllerPane put: aValue with: #controllerPaneChanged! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/22/2006 18:46'!
currentPos
	^ self horizontalPos @ self verticalPos! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/22/2006 18:49'!
currentPos: pos
	self horizontalPos: pos x.
	self verticalPos: pos y.! !

!SqBoardTray methodsFor: 'defaults' stamp: 'minami 3/9/2006 14:19'!
defaultBackgroundColor
	^ Color lightGray! !

!SqBoardTray methodsFor: 'initialize' stamp: 'minami 3/15/2006 03:03'!
destroy
	self audioChatPlayer destroy.
	self board destroy.
	super destroy.! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:30'!
hBar
	^ self boardHolder costume hScrollBar! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:31'!
horizontalPos
	^ self hBar value! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:32'!
horizontalPos: int
	self hBar value: int! !

!SqBoardTray methodsFor: 'initialize' stamp: 'minami 3/17/2006 16:45'!
initialize
	super initialize.

	self define: #controllerPane as: self buildControllerPane.
	self define: #audioChatPlayer as: self buildAudioChatPlayer.
	self define: #boardHolder as: self buildBoardHolder.
	self define: #settingsButton as: self buildSettingsButton.
	! !

!SqBoardTray methodsFor: 'testing' stamp: 'minami 3/9/2006 15:43'!
isDropAcceptable
	^ false.! !

!SqBoardTray methodsFor: 'events' stamp: 'mu 3/17/2006 14:58'!
onSettingsButtonFired
	<on: fire in: settingsButton>

	self board ifNil: [^ self].
	self openSettingsMenu! !

!SqBoardTray methodsFor: 'menu' stamp: 'mu 3/17/2006 15:00'!
openSettingsMenu
	| menu |
	menu := CMenu new.
	self addExtentMenuOn: menu.
	menu add: 'TEST' target: CDialog action: #inform: argument: 'The last item was selected'.
	menu label: 'Settings'.
	^menu open! !

!SqBoardTray methodsFor: 'scaling' stamp: 'mu 4/3/2006 17:24'!
setBoardScale: aValue

	self board ifNotNilDo: [:b |
		b scale: aValue.
		b globalPosition: b container globalPosition
	]! !

!SqBoardTray methodsFor: 'actions' stamp: 'mu 3/27/2006 10:11'!
setBoard: aBoard
	self board: aBoard.
	self boardHolder addLast: aBoard.
	self audioChatPlayer client: (SqAudioChatFacade on: aBoard).! !

!SqBoardTray methodsFor: 'accessing' stamp: 'mu 3/17/2006 14:47'!
settingsButton
	"Answer the settingsButton of the receiver"
	<bewareOf: #settingsButtonChanged>
	^self propertyValueAt: #settingsButton! !

!SqBoardTray methodsFor: 'accessing' stamp: 'mu 3/17/2006 14:47'!
settingsButton: aValue
	"Modify the receiver's settingsButton"
	^self propertyValueAt: #settingsButton put: aValue with: #settingsButtonChanged! !

!SqBoardTray methodsFor: 'initialize' stamp: 'minami 3/17/2006 16:45'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.
	self extent: 400@300.

	self controllerPane addLast: settingsButton.
	self controllerPane addLast: audioChatPlayer.
	self addLast: self controllerPane.
	self addLast: self boardHolder.
! !

!SqBoardTray methodsFor: 'actions' stamp: 'minami 3/10/2006 11:57'!
startAudioChat
	self audioChatPlayer start! !

!SqBoardTray methodsFor: 'actions' stamp: 'minami 3/10/2006 11:57'!
stopAudioChat
	self audioChatPlayer stop! !

!SqBoardTray methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:30'!
title
	^ self board
		ifNil: ['not login']
		ifNotNil: [self board boardName]! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:29'!
vBar
	^ self boardHolder costume vScrollBar! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:31'!
verticalPos
	^ self vBar value! !

!SqBoardTray methodsFor: 'board access' stamp: 'minami 3/9/2006 15:32'!
verticalPos: int
	self vBar value: int! !

CPlayer subclass: #SqLevelIndicator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqLevelIndicator defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="level" toSet="level:" changeEvent="levelChanged">level</field>
	<field toGet="backgroundColor" toSet="backgroundColor:" changeEvent="backgroundColorChanged">backgroundColor</field>
</fields>'!

!SqLevelIndicator class methodsFor: 'examples' stamp: 'minami 3/7/2006 11:50'!
ex01
"
SqLevelIndicator ex01
"
	| indicator |
	indicator := SqLevelIndicator openInHand.
	0 to: 1 by: 0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].

	1 to: 0 by: -0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor
	"Answer the backgroundColor of the receiver"
	<bewareOf: #backgroundColorChanged>
	^self propertyValueAt: #backgroundColor! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor: aValue
	"Modify the receiver's backgroundColor"
	^self propertyValueAt: #backgroundColor put: aValue with: #backgroundColorChanged! !

!SqLevelIndicator methodsFor: 'drawing' stamp: 'minami 3/7/2006 11:46'!
drawOn: aCanvas in: drawingBounds
	| bw w x r |
	bw := self borderWidth.
	aCanvas
		frameAndFillRectangle: drawingBounds 
		fillColor: self color 
		borderWidth: bw 
		borderColor: self borderColor.

	w := ((drawingBounds width - (bw * 2)) * (((1 - level) min: 1) max: 0)) asInteger.
	x := drawingBounds topRight x - w.
	r := x @ (drawingBounds topLeft y + bw) corner: drawingBounds bottomRight - bw.

	aCanvas fillRectangle: r color: self backgroundColor! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/16/2006 07:47'!
initialize
	super initialize.
	self userDraw: true.
	
	level := 0.
! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level
	"Answer the level of the receiver"
	<bewareOf: #levelChanged>
	^self propertyValueAt: #level! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level: aValue
	"Modify the receiver's level"
	^self propertyValueAt: #level put: aValue with: #levelChanged! !

!SqLevelIndicator methodsFor: 'events' stamp: 'minami 3/7/2006 11:12'!
onLevelChanged
	<on: levelChanged>

	self invalidate! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:28'!
reset
	self level: 0! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/27/2006 06:46'!
setupCostume
	super setupCostume.

	self borderWidth: 1.
	self borderColor: Color white.
	self color: Color yellow.
	self backgroundColor: Color veryLightGray..

! !
SqAudioChatCostume initialize!
SqClient initialize!
SqSquareDiscovery initialize!
